unit MainUnit;

{$mode objfpc}{$H+}{$M+}

interface

uses
  Classes, SysUtils, FileUtil, LazSerial, LResources, Forms, Controls,
  Graphics, Dialogs, StrUtils,

  {$IFDEF MSWINDOWS}
     MMSystem, Windows, Registry,
  {$ENDIF}

  StdCtrls, ExtCtrls, Buttons, ComCtrls, IniFiles, DateUtils,
  Unit_CONS, wincpm, BitOp, Types;




// Abfrage von CONST und CONIN vom Controller
{$DEFINE CONST_Abfrage}


const
  CRLF = CHR($0D)+CHR($0A);
//  CR = CHR($0D);
  XOFF = CHR($13);
  Laenge_ConsoleIn = 20;
  VersionsText = 'CP/M CONSOLE - Version 4.0 (c) by Ronald Daleske';


  Length_Color_List = 100000;

  // Farben
  cl_dunkel_gruen = $009500;
  cl_dunkel_blau  = $650106;
  cl_dunkel_rot   = $0000CA;
  cl_dunkel_braun = $000066;

  COM_Port_Max = 99;


  {$IFDEF MSWINDOWS}
     Pfadtrenner = '\';
  {$ELSE}
     Pfadtrenner = '/';
  {$ENDIF}





type


  REC_Port_Liste = record
    Port_Name, Port_Typ : String;
  end;



  { TForm_Console }

  TForm_Console = class(TForm)
    BitBtn_Save_Screen: TBitBtn;
    BitBtn_Print_Save: TBitBtn;
    Button_LOG_Meldungen_Save: TButton;
    Button_LOG_Meldungen_Clear: TButton;
    Button_Font_uebernehmen: TButton;
    Button_Close: TButton;
    CheckBox_SOUND: TCheckBox;
    CheckBox_GV_D2_READER: TCheckBox;
    CheckBox_GV_D3_DRIVE: TCheckBox;
    CheckBox_GV_D4_SOUND: TCheckBox;
    CheckBox_GV_D5_LIST: TCheckBox;
    CheckBox_GV_D6_CONIN: TCheckBox;
    CheckBox_GV_D7_CONOUT: TCheckBox;
    CheckBox_XOFF: TCheckBox;
    CheckBox_LOG_TERM: TCheckBox;
    CheckBox_LOG_WRITE: TCheckBox;
    CheckBox_LOG_READ: TCheckBox;
    CheckBox_LOG_CONOUT: TCheckBox;
    CheckBox_LOG_CONIN: TCheckBox;
    ComboBox_Font_Namen: TComboBox;
    ComboBox_FontSize: TComboBox;
    ComboBox_TIE: TComboBox;
    ComboBoxBauds: TComboBox;
    ComboBoxPort: TComboBox;
    Image1: TImage;
    Image_DISK_MONITOR: TImage;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label_TRK: TLabel;
    Label_SEC: TLabel;
    Label_DISK: TLabel;
    LazSerial1: TLazSerial;
    LED_GE: TImage;
    LED_GN: TImage;
    LED_RT: TImage;
    Image_rt: TImage;
    Image_gn: TImage;
    Label1: TLabel;
    Label2: TLabel;
    PageControl1: TPageControl;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel6: TPanel;
    TabSheet_REST: TTabSheet;
    TabSheet_CONOUT: TTabSheet;
    TabSheet_DRIVE: TTabSheet;
    ListBox_Meldungen: TListBox;
    OpenDialog_IMAGE: TOpenDialog;
    OpenDialog_BOOT: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    ConnectButton: TButton;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure BitBtn_Print_SaveClick(Sender: TObject);
    procedure BitBtn_Save_ScreenClick(Sender: TObject);
    procedure BitBtn_Terminal_SaveClick(Sender: TObject);
    procedure Button_Font_uebernehmenClick(Sender: TObject);
    procedure Button_CloseClick(Sender: TObject);
    procedure Button_LOG_Meldungen_ClearClick(Sender: TObject);
    procedure Button_LOG_Meldungen_SaveClick(Sender: TObject);
    procedure CheckBox_GV_D2_READERChange(Sender: TObject);
    procedure CheckBox_GV_D3_DRIVEChange(Sender: TObject);
    procedure CheckBox_GV_D4_SOUNDChange(Sender: TObject);
    procedure CheckBox_GV_D5_LISTChange(Sender: TObject);
    procedure CheckBox_GV_D6_CONINChange(Sender: TObject);
    procedure CheckBox_GV_D7_CONOUTChange(Sender: TObject);
    procedure CheckBox_LOG_CONINChange(Sender: TObject);
    procedure CheckBox_LOG_CONOUTChange(Sender: TObject);
    procedure CheckBox_LOG_READChange(Sender: TObject);
    procedure CheckBox_LOG_WRITEChange(Sender: TObject);
    procedure ComboBox_FontSizeChange(Sender: TObject);
    procedure ComboBox_TIEChange(Sender: TObject);
    procedure ConnectButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LazSerial1RxData(Sender: TObject);
    procedure ListBox_MeldungenDrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
    procedure TerminalKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
      );
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { private declarations }
    PortConnected : Boolean;
    FIni : TMemIniFile;
    PRINT_File_Name : String;
    ReadCOM : String;
    VAR_SECTOR, VAR_TRACK, VAR_DISKNO,
    F1_x, F1_y, F1_Hoehe : Integer;
    BOOT_File, PRINT_File : TMemoryStream;
    ConsoleIn  : Array [1..Laenge_ConsoleIn] of Byte;
    Pos_ConsoleIn : Byte;
    Trace_Liste : TStringList;
    DRIVE_A : String;
    Com_Port : string;
    ComboBoxPort_Liste : TStringList;
    DISK_MONITOR_Zaehler : Integer;
    letzte_Pruefsumme : Integer;
    DEVICE_VECTOR_String : String;
    Color_List : Array [0..Length_Color_List] of TColor;

    COM_Port_Array : Array [0..COM_Port_Max] of REC_Port_Liste;
    COM_Port_Array_Zeiger : Integer;


    procedure Port_verbinden;
    procedure DISK_MONITOR_OFF;
    procedure DISK_MONITOR_READ;
    procedure DISK_MONITOR_WRITE;
    procedure Read_IMAGE_Sektor_unkomp(ISEC_LFD_NR : Byte);
    procedure Read_IMAGE_Sektor_komp(ISEC_LFD_NR : Byte);
    procedure Read_IMAGE_Sektor_komp34(ISEC_LFD_NR : Byte);
    procedure Write_IMAGE_Sektor_unkomp(Zeile : String);
    procedure Write_IMAGE_Sektor_komp(Zeile : String);
    procedure WRITE_TO_LIST(DatenByte : Byte);
    procedure sende_Datum_und_Zeit;
    procedure sende_CONIN;
    procedure sende_CONST;
    procedure sende_DEVICE_VECTOR;
    procedure ComPort_laden;
    procedure GetSerialPortNamesExt;
    procedure DISK_MONITOR_SOUND;



  public
    { public declarations }
    Programm_File_Pfad, PRINT_File_Ordner : string;
    F2_x, F2_y : Integer;
    LOG_CONIN, LOG_CONOUT, LOG_DEVICE_VECTOR,
    LOG_READ, LOG_WRITE, RW_Sperre2 : Boolean;
    DEVICE_VECTOR_Byte : Byte;

    procedure Send_Char_To_Serial(Zeichen : Byte);
    procedure ComboBox_FontSize_abfragen;
    procedure ComboBox_FontSize_aendern;
    function suche_Font_Name : Integer;
    procedure ListBox_Meldungen_Clear;
    procedure ListBox_Meldungen_Add_Item_Color(AI_Text : String;
                                               AI_Color : TColor);

  end; { TForm_Console }

var
  Form_Console: TForm_Console;


  // globale Variablen
  GV_Font_Name : String;
  CONS_FontSize : Integer;
  setzt_Focus_bei_CONOUT : Boolean;


  const ligneMax = 30;

implementation

{ TForm_Console }





procedure TForm_Console.FormCreate(Sender: TObject);
var
  Baud_Rate: integer;
  DV_counter : Integer;
  DEVICE_VECTOR_String2 : String;
begin

  ComboBoxPort.Clear;

  LOG_DEVICE_VECTOR:=TRUE;

  Form_Console.Caption:=VersionsText;

  // ListBox_Meldungen Emulation
  ComboBox_TIE.Items.Add('VT100');
  ComboBox_TIE.Items.Add('VT52');
  ComboBox_TIE.Items.Add('PC1715');
  ComboBox_TIE.Items.Add('ANSI');
  ComboBox_TIE.Items.Add('ADM31');

  Programm_File_Pfad := ExtractFilePath(Application.ExeName);
  FIni := TMemIniFile.Create(Programm_File_Pfad +'CONSOLE64.ini');

  // IniFile ComPort
  Com_Port := FIni.ReadString('ComPort', 'ComPort', 'COM1');
  Baud_Rate := FIni.ReadInteger('ComPort', 'BaudRate', 0);

  // IniFile PRINT
  PRINT_File_Name := FIni.ReadString('PRINT', 'File_Name', 'PRINT.txt');
  PRINT_File_Ordner := FIni.ReadString('PRINT', 'File_Ordner', 'PRINT');

  // IniFile FORM
  F1_x := FIni.ReadInteger('FORM', 'F1_x', 0);
  F1_y := FIni.ReadInteger('FORM', 'F1_y', 0);
  F1_Hoehe := FIni.ReadInteger('FORM', 'F1_Hoehe', 670);
  F2_x := FIni.ReadInteger('FORM', 'F2_x', 0);
  F2_y := FIni.ReadInteger('FORM', 'F2_y', 0);

  LOG_CONIN := FIni.ReadBool('FORM', 'LOG_CONIN', true);
  CheckBox_LOG_CONIN.Checked := LOG_CONIN;
  LOG_CONOUT := FIni.ReadBool('FORM', 'LOG_CONOUT', true);
  CheckBox_LOG_CONOUT.Checked := LOG_CONOUT;
  LOG_READ := FIni.ReadBool('FORM', 'LOG_READ', true);
  CheckBox_LOG_READ.Checked := LOG_READ;
  LOG_WRITE := FIni.ReadBool('FORM', 'LOG_WRITE', true);
  CheckBox_LOG_WRITE.Checked := LOG_WRITE;

  CheckBox_LOG_TERM.Checked := FIni.ReadBool('FORM', 'LOG_Term', false);
  CheckBox_XOFF.Checked := FIni.ReadBool('FORM', 'send_XOFF', true);


  // IniFile ListBox_Meldungen

  ComboBox_TIE.ItemIndex := FIni.ReadInteger('CONOUT', 'Index_Emulation', 0);
  DEVICE_VECTOR_String := FIni.ReadString('CONOUT', 'DEVICE_VECTOR', '11111000');
  GV_Font_Name := FIni.ReadString('CONOUT', 'FONT_NAME', 'Courier New');

  CheckBox_SOUND.Checked := FIni.ReadBool('CONOUT', 'play_SOUND', true);



  // Geraeteverwaltung und DEVICE_VECTOR
  if Length(DEVICE_VECTOR_String)=8 then begin

    DEVICE_VECTOR_String2:='';

    for DV_counter:=1 to 8 do begin

      if DEVICE_VECTOR_String[DV_counter]='0' then
        DEVICE_VECTOR_String2:=DEVICE_VECTOR_String2+'0'
      else
        DEVICE_VECTOR_String2:=DEVICE_VECTOR_String2+'1'

    end;

  end
  else
    DEVICE_VECTOR_String:='11111000';

  DEVICE_VECTOR_Byte := StrToInt( '%' + DEVICE_VECTOR_String2);


  {
    Konfiguration WHO_ARE_YOU - Byte
    D7 - CONOUT
    D6 - CONIN
    D5 - LIST
    D4 - SOUND
    D3 - DIVE
    D2 - READER
    D1 - N.N.
    D0 - N.N.
  }

  // Setzen der Check-Boxen fuer die Geraeteverwaltung
  if (DEVICE_VECTOR_Byte and %10000000=0) then
    CheckBox_GV_D7_CONOUT.Checked:=false
  else
    CheckBox_GV_D7_CONOUT.Checked:=true;


  if (DEVICE_VECTOR_Byte and %01000000=0) then
    CheckBox_GV_D6_CONIN.Checked:=false
  else
    CheckBox_GV_D6_CONIN.Checked:=true;


  if (DEVICE_VECTOR_Byte and %00100000=0) then
    CheckBox_GV_D5_LIST.Checked:=false
  else
    CheckBox_GV_D5_LIST.Checked:=true;


  if (DEVICE_VECTOR_Byte and %00010000=0) then
    CheckBox_GV_D4_SOUND.Checked:=false
  else
    CheckBox_GV_D4_SOUND.Checked:=true;


  if (DEVICE_VECTOR_Byte and %00001000=0) then
    CheckBox_GV_D3_DRIVE.Checked:=false
  else
    CheckBox_GV_D3_DRIVE.Checked:=true;


  if (DEVICE_VECTOR_Byte and %00000100=0) then
    CheckBox_GV_D2_READER.Checked:=false
  else
    CheckBox_GV_D2_READER.Checked:=true;


  // IniFile CPM
  DRIVE_A := FIni.ReadString('CPM', 'DRIVE_A', 'DRIVE_A');



  ReadCOM:='';
  ListBox_Meldungen.Clear;


  ComboBoxPort_Liste := TStringList.Create;
  ComPort_laden;



  ComboBoxBauds.Items.Add('  9600');
  ComboBoxBauds.Items.Add(' 19200');
  ComboBoxBauds.Items.Add(' 38400');
  ComboBoxBauds.Items.Add(' 57600');
  ComboBoxBauds.Items.Add(' 62500');
  ComboBoxBauds.Items.Add('115200');
  ComboBoxBauds.Items.Add('100000');
  ComboBoxBauds.Items.Add('125000');
  ComboBoxBauds.Items.Add('128000');
  ComboBoxBauds.Items.Add('200000');
  ComboBoxBauds.Items.Add('230400');
  ComboBoxBauds.Items.Add('250000');
  ComboBoxBauds.Items.Add('460800');
  ComboBoxBauds.Items.Add('500000');
  ComboBoxBauds.Items.Add('921600');

  ComboBoxBauds.ItemIndex:=Baud_Rate;



  ConnectButton.Caption:='Verbinden';
  PortConnected:=false;

  Image_rt.Visible:=true;
  Image_gn.Visible:=false;



  Image1.Left:=3;
  Image1.Top:=3;

  with Image1.Picture.Bitmap do begin
    Width:=Panel4.Width-6;
    Height:=Panel4.Height-10;
  end;


  Image1.Canvas.Brush.Color:= clWhite;
  Image1.Canvas.Pen.Color:= clBlack;
  Image1.Canvas.Pen.Width:=1;
  Image1.Canvas.Rectangle(0,0,Image1.Width,Image1.Height);





  // IMAGE
  wcpm_LW_A := Twcpm.Create(ListBox_Meldungen,
                            Programm_File_Pfad+'\'+DRIVE_A);

  // nur dpb_FormatE_8MB
  wcpm_LW_A.load_dpb_FormatE_8MB;
  wcpm_LW_A.Import_Files_To_Image;


  // PRINT
  PRINT_File := TMemoryStream.Create;

  LED_GE.Left:=Image_DISK_MONITOR.Left+48;
  LED_GN.Left:=Image_DISK_MONITOR.Left+128;
  LED_RT.Left:=Image_DISK_MONITOR.Left+208;

  LED_GE.Top:=Image_DISK_MONITOR.Top+58;
  LED_GN.Top:=Image_DISK_MONITOR.Top+58;
  LED_RT.Top:=Image_DISK_MONITOR.Top+58;

  LABEL_DISK.Left:=Image_DISK_MONITOR.Left+46;
  LABEL_TRK.Left:=Image_DISK_MONITOR.Left+132;
  LABEL_SEC.Left:=Image_DISK_MONITOR.Left+212;

  LABEL_DISK.Top:=Image_DISK_MONITOR.Top+32;
  LABEL_SEC.Top:=Image_DISK_MONITOR.Top+32;
  LABEL_TRK.Top:=Image_DISK_MONITOR.Top+32;

  LABEL_DISK.Font.Size:=9;
  LABEL_SEC.Font.Size:=9;
  LABEL_TRK.Font.Size:=9;

  DISK_MONITOR_OFF;
  RW_Sperre2:=false;
  Pos_ConsoleIn := 0;

  Trace_Liste := TStringList.Create;

  DISK_MONITOR_Zaehler:=0;
  Timer1.Enabled:=true;

  letzte_Pruefsumme:=0;



  ComboBox_FontSize.Items.Add('FontSize=6');
  ComboBox_FontSize.Items.Add('FontSize=8');
  ComboBox_FontSize.Items.Add('FontSize=10');
  ComboBox_FontSize.Items.Add('FontSize=14');
  ComboBox_FontSize.Items.Add('FontSize=16');
  ComboBox_FontSize.Items.Add('FontSize=18');
  ComboBox_FontSize.Items.Add('FontSize=20');
  ComboBox_FontSize.Items.Add('FontSize=22');
  ComboBox_FontSize.Items.Add('FontSize=24');
  ComboBox_FontSize.Items.Add('FontSize=26');


  ComboBox_FontSize.ItemIndex := FIni.ReadInteger('CONOUT', 'Index_FontSize', 2);

  ComboBox_Font_Namen.Items.Assign(Screen.Fonts);

  ComboBox_Font_Namen.ItemIndex:=suche_Font_Name;


  ListBox_Meldungen_Clear;



end; { procedure TForm_Console.FormCreate }




function TForm_Console.suche_Font_Name : Integer;
var
  FN_ItemIndex,
  FN_Zaehler : Integer;
  FN_Name_gefunden : Boolean;
begin

  FN_ItemIndex:=-1;

  for FN_Zaehler:=0 to ComboBox_Font_Namen.Items.Count-1 do begin

    if ComboBox_Font_Namen.Items[FN_Zaehler]=GV_Font_Name then begin
      FN_ItemIndex:=FN_Zaehler;
    end; { if ComboBox_Font_Namen.Items[FN_Zaehler]=GV_Font_Name then }

  end; { for FN_Zaehler:=0 to ComboBox_Font_Namen.Items.Count-1 do }



  if FN_ItemIndex=-1 then begin

    FN_ItemIndex:=0;

    for FN_Zaehler:=0 to ComboBox_Font_Namen.Items.Count-1 do begin

      if ComboBox_Font_Namen.Items[FN_Zaehler]='Courier New' then begin
        FN_ItemIndex:=FN_Zaehler;
      end; { if ComboBox_Font_Namen.Items[FN_Zaehler]=GV_Font_Name then }

    end; { for FN_Zaehler:=0 to ComboBox_Font_Namen.Items.Count-1 do }

  end; { if FN_ItemIndex=-1 then }


  Result:=FN_ItemIndex;

end; { function TForm_Console.suche_Font_Name }











// ****************
// *** COM-Port ***
// ****************







procedure TForm_Console.GetSerialPortNamesExt;
var
  reg  : TRegistry;
  com_list : TStringList;
  n    : integer;
  pn,fn: string;



  function findFriendlyName(key: string; port: string): string;
  var
    r : TRegistry;
    k : TStringList;
    i : Integer;
    ck: string;
    rs: string;
  begin

    r := TRegistry.Create;
    k := TStringList.Create;

    r.RootKey := HKEY_LOCAL_MACHINE;
    r.OpenKeyReadOnly(key);
    r.GetKeyNames(k);
    r.CloseKey;

    try
      for i := 0 to k.Count - 1 do begin

        ck := key + k[i] + '\'; // current key

        // looking for "PortName" stringvalue in "Device Parameters" subkey
        if r.OpenKeyReadOnly(ck + 'Device Parameters') then begin

          if r.ReadString('PortName') = port then begin

            r.CloseKey;
            r.OpenKeyReadOnly(ck);
            rs := r.ReadString('FriendlyName');
            Break;

          end { if r.ReadString('PortName') = port then }

        end { if r.OpenKeyReadOnly(ck + 'Device Parameters') then }
        // keep looking on subkeys for "PortName"
        else begin

          if r.OpenKeyReadOnly(ck) and r.HasSubKeys then begin

            rs := findFriendlyName(ck, port);

            if rs <> '' then Break;

          end; { if r.OpenKeyReadOnly(ck) and r.HasSubKeys then }

        end; { if r.OpenKeyReadOnly(ck + 'Device Parameters') then }

      end; { for i := 0 to k.Count - 1 do }

      result := rs;

    finally
      r.Free;
      k.Free;
    end; // try ...

  end; { function findFriendlyName ... }



begin

  com_list := TStringList.Create;
  reg      := TRegistry.Create;


  try

    reg.RootKey := HKEY_LOCAL_MACHINE;

    if reg.OpenKeyReadOnly('HARDWARE\DEVICEMAP\SERIALCOMM') then begin
      reg.GetValueNames(com_list);

      for n := 0 to com_list.Count - 1 do begin

        pn := reg.ReadString(com_list[n]);
        fn := findFriendlyName('\System\CurrentControlSet\Enum\', pn);

        if POS('(COM',fn)>0 then begin
          Delete(fn,POS(' (COM',fn),10);
        end;

        COM_Port_Array[COM_Port_Array_Zeiger].Port_Name:=pn;
        COM_Port_Array[COM_Port_Array_Zeiger].Port_Typ:=fn;
        Inc(COM_Port_Array_Zeiger);

      end; // for n := 0 to l.Count - 1 ...

    end; // if reg.OpenKeyReadOnly('HARDWARE\DEVICEMAP\SERIALCOMM') ...

  finally

    reg.Free;

  end; // try ...

end; { function TForm_Console.GetSerialPortNamesExt }







procedure TForm_Console.ComPort_laden;
var
  CPA_Zaehler : Integer;
begin

  COM_Port_Array_Zeiger:=0;

  GetSerialPortNamesExt;

  ComboBoxPort.Items.Clear;

  ComboBoxPort.ItemIndex:=-1;


  for CPA_Zaehler:=0 to COM_Port_Array_Zeiger-1 do begin

    ComboBoxPort.Items.Add(COM_Port_Array[CPA_Zaehler].Port_Name+
                        ' = '+
                        COM_Port_Array[CPA_Zaehler].Port_Typ);

    if Com_Port=COM_Port_Array[CPA_Zaehler].Port_Name then begin
      ComboBoxPort.ItemIndex:=CPA_Zaehler;
    end;

  end; { for CPA_Zaehler:=0 to COM_Port_Array_Zeiger-1 do }

  if ComboBoxPort.ItemIndex=-1 then
    ComboBoxPort.ItemIndex:=ComboBoxPort.Items.Count-1;

end; { procedure TForm_Console.ComPort_laden }






procedure TForm_Console.Port_verbinden;
var
  bauds: Integer;
  PortName, BaudRate : String;
begin

  if not LazSerial1.Active then begin

    BaudRate:=ComboBoxBauds.Items[ComboBoxBauds.itemindex];

    case ComboBoxBauds.itemindex of

      00 : LazSerial1.BaudRate:=br__9600;
      01 : LazSerial1.BaudRate:=br_19200;
      02 : LazSerial1.BaudRate:=br_38400;
      03 : LazSerial1.BaudRate:=br_57600;
      04 : LazSerial1.BaudRate:=br_62500;
      05 : LazSerial1.BaudRate:=br100000;
      06 : LazSerial1.BaudRate:=br115200;
      07 : LazSerial1.BaudRate:=br125000;
      08 : LazSerial1.BaudRate:=br128000;
      09 : LazSerial1.BaudRate:=br200000;
      10 : LazSerial1.BaudRate:=br230400;
      11 : LazSerial1.BaudRate:=br250000;
      12 : LazSerial1.BaudRate:=br460800;
      13 : LazSerial1.BaudRate:=br500000;
      14 : LazSerial1.BaudRate:=br921600;

    end; { case ComboBoxBauds.itemindex of }


    PortName:=COM_Port_Array[ComboBoxPort.ItemIndex].Port_Name;
    LazSerial1.Device:=PortName;

    LazSerial1.Open;

    ConnectButton.Caption:='Trennen';
    PortConnected:=true;
    Image_rt.Visible:=false;
    Image_gn.Visible:=true;
    ListBox_Meldungen_Add_Item_Color('--- Port '+LazSerial1.Device+
                    ' ist mit einer Baudrate von '+BaudRate+' verbunden',cl_dunkel_gruen);
  end
  else begin
    ConnectButton.Caption:='Verbinden';
    PortConnected:=false;

    LazSerial1.Close;

    Image_gn.Visible:=false;
    Image_rt.Visible:=true;
    ListBox_Meldungen_Add_Item_Color('--- Port wurde getrennt',cl_dunkel_rot);

  {  ListBox_Meldungen.Items.Add('--- Port wurde getrennt');   }

  end;

end; { procedure TForm_Console.Port_verbinden }




procedure TForm_Console.ConnectButtonClick(Sender: TObject);
begin
  Port_verbinden;
end; { procedure TForm_Console.ConnectButtonClick }





// **************************************
// **** Geraeteverwaltung
// **************************************

procedure TForm_Console.CheckBox_GV_D7_CONOUTChange(Sender: TObject);
begin

  if CheckBox_GV_D7_CONOUT.Checked then
    DEVICE_VECTOR_Byte:=DEVICE_VECTOR_Byte or  %10000000
  else
    DEVICE_VECTOR_Byte:=DEVICE_VECTOR_Byte and %01111111;

end; { procedure TForm_Console.CheckBox_GV_B7_CONOUTChange }



procedure TForm_Console.CheckBox_GV_D6_CONINChange(Sender: TObject);
begin

  if CheckBox_GV_D6_CONIN.Checked then
    DEVICE_VECTOR_Byte:=DEVICE_VECTOR_Byte or  %01000000
  else
    DEVICE_VECTOR_Byte:=DEVICE_VECTOR_Byte and %10111111;

end; { procedure TForm_Console.CheckBox_GV_B6_CONINChange }




procedure TForm_Console.CheckBox_GV_D5_LISTChange(Sender: TObject);
begin

  if CheckBox_GV_D5_LIST.Checked then
    DEVICE_VECTOR_Byte:=DEVICE_VECTOR_Byte or  %00100000
  else
    DEVICE_VECTOR_Byte:=DEVICE_VECTOR_Byte and %11011111;

end; { procedure TForm_Console.CheckBox_GV_D5_LISTChange }




procedure TForm_Console.CheckBox_GV_D4_SOUNDChange(Sender: TObject);
begin

  if CheckBox_GV_D4_SOUND.Checked then
    DEVICE_VECTOR_Byte:=DEVICE_VECTOR_Byte or  %00010000
  else
    DEVICE_VECTOR_Byte:=DEVICE_VECTOR_Byte and %11101111;

end; { procedure TForm_Console.CheckBox_GV_D4_SOUNDChange }




procedure TForm_Console.CheckBox_GV_D3_DRIVEChange(Sender: TObject);
begin

  if CheckBox_GV_D3_DRIVE.Checked then
    DEVICE_VECTOR_Byte:=DEVICE_VECTOR_Byte or  %00001000
  else
    DEVICE_VECTOR_Byte:=DEVICE_VECTOR_Byte and %11110111;

end; { procedure TForm_Console.CheckBox_GV_D3_DRIVE }




procedure TForm_Console.CheckBox_GV_D2_READERChange(Sender: TObject);
begin

  if CheckBox_GV_D2_READER.Checked then
    DEVICE_VECTOR_Byte:=DEVICE_VECTOR_Byte or  %00000100
  else
    DEVICE_VECTOR_Byte:=DEVICE_VECTOR_Byte and %11111011;

end; { procedure TForm_Console.CheckBox_GV_D2_READER }








procedure TForm_Console.BitBtn_Print_SaveClick(Sender: TObject);
begin
  PRINT_File.SaveToFile(Programm_File_Pfad+PRINT_File_Ordner+Pfadtrenner+PRINT_File_Name);
end; { procedure TForm_Console.BitBtn_Print_SaveClick }





procedure TForm_Console.BitBtn_Save_ScreenClick(Sender: TObject);
begin
  Form_CONS.Save_Screen;
end; { procedure TForm_Console.BitBtn_Save_ScreenClick }

procedure TForm_Console.BitBtn_Terminal_SaveClick(Sender: TObject);
begin

end;





procedure TForm_Console.Button_Font_uebernehmenClick(Sender: TObject);
begin
  GV_Font_Name:=ComboBox_Font_Namen.Items[ComboBox_Font_Namen.ItemIndex];
  Form_CONS.Formular_neu_zeichnen;
end; { procedure TForm_Console.Button_Font_uebernehmenClick }






procedure TForm_Console.Send_Char_To_Serial(Zeichen : Byte);
begin
  if not PortConnected then
    Port_verbinden;

  if RW_Sperre2 then begin
    ConsoleIn[Pos_ConsoleIn]:=Zeichen;
    Inc(Pos_ConsoleIn);
    if Pos_ConsoleIn>Laenge_ConsoleIn then
      Dec(Pos_ConsoleIn);

  end
  else begin

    LazSerial1.WriteData('T'+IntToHex(Zeichen,2)+CRLF);

    if LOG_CONIN then
      ListBox_Meldungen_Add_Item_Color('<< CONIN='+IntToHex(Zeichen,2),cl_dunkel_braun);


  end; { if RW_Sperre then }

end; { procedure TForm_Console.Send_Char_To_Serial }




// *** DISK_MONITOR ***

procedure TForm_Console.DISK_MONITOR_SOUND;
var
  BELL_PFAD : String;
begin

  {$IFDEF MSWINDOWS}

     if CheckBox_SOUND.Checked then begin

       BELL_PFAD:=Form_Console.Programm_File_Pfad+
                            Ordner_WAV+Pfadtrenner+'disk.wav';

       If FileExists(BELL_PFAD) Then begin
         sndPlaySound(PChar(BELL_PFAD),SND_NODEFAULT Or SND_ASYNC);
       end; { If FileExists(BELL_PFAD) Then }

     end; { if CheckBox_SOUND.Checked then }

  {$ENDIF}

end; { procedure TForm_Console.DISK_MONITOR_SOUND }


procedure TForm_Console.DISK_MONITOR_OFF;
var
  Zeichen : Byte;
begin
  LED_GE.Visible:=true;
  LED_GN.Visible:=false;
  LED_RT.Visible:=false;

  LABEL_DISK.Visible:=false;
  LABEL_SEC.Visible:=false;
  LABEL_TRK.Visible:=false;

  RW_Sperre2:=false;

  while Pos_ConsoleIn>0 do begin
    Zeichen:=ConsoleIn[Pos_ConsoleIn];
    Dec(Pos_ConsoleIn);

    LazSerial1.WriteData('T'+IntToHex(Zeichen,2)+CRLF);

    if LOG_CONIN then
      ListBox_Meldungen_Add_Item_Color('<< CONIN='+IntToHex(Zeichen,2),cl_dunkel_braun);


  end; { while Pos_ConsoleIn>0 do }

end; { procedure TForm_Console.DISK_MONITOR_OFF }





procedure TForm_Console.DISK_MONITOR_READ;
var
  LW_Buchstabe_Integer : Integer;
  LW_Buchstabe_Char : Char;
begin

  LED_GE.Visible:=false;
  LED_GN.Visible:=true;
  LED_RT.Visible:=false;

  LW_Buchstabe_Integer:=ORD('A')+VAR_DISKNO;
  LW_Buchstabe_Char:=CHR(LW_Buchstabe_Integer);
  LABEL_DISK.Caption:=LW_Buchstabe_Char;

  LABEL_SEC.Caption:=IntToStr(VAR_SECTOR);
  LABEL_TRK.Caption:=IntToStr(VAR_TRACK);

  LABEL_DISK.Visible:=true;
  LABEL_SEC.Visible:=true;
  LABEL_TRK.Visible:=true;

  Timer2.Enabled:=true;

end; { procedure TForm_Console.DISK_MONITOR_READ }






procedure TForm_Console.DISK_MONITOR_WRITE;
begin

  LED_GE.Visible:=false;
  LED_GN.Visible:=false;
  LED_RT.Visible:=true;

  LABEL_DISK.Caption:=IntToStr(VAR_DISKNO);
  LABEL_SEC.Caption:=IntToStr(VAR_SECTOR);
  LABEL_TRK.Caption:=IntToStr(VAR_TRACK);

  LABEL_DISK.Visible:=true;
  LABEL_SEC.Visible:=true;
  LABEL_TRK.Visible:=true;

  Timer2.Enabled:=true;

end; { procedure TForm_Console.DISK_MONITOR_WRITE }






// *** READ WRITE ***






procedure TForm_Console.Read_IMAGE_Sektor_unkomp(ISEC_LFD_NR : Byte);
var
  B_Zaehler : Integer;
  Zeile : String;
  B_Byte : Byte;
  I_POS : LongInt;

begin

  if not PortConnected then
    Port_verbinden;

  // VAR_SECTOR, VAR_TRACK, VAR_DISKNO

  if ISEC_LFD_NR=0 then
    DISK_MONITOR_READ;


  I_POS:=(ISEC_LFD_NR*16)+(((VAR_TRACK*wcpm_LW_A.DPB.SPT)+(VAR_SECTOR))*128);

  if LOG_READ and (ISEC_LFD_NR=0) then
    ListBox_Meldungen_Add_Item_Color('Sec='+IntToStr(VAR_SECTOR)+
                       ' Trk='+IntToStr(VAR_TRACK)+' Dsk='+IntToStr(VAR_DISKNO)
                       ,cl_dunkel_braun);

  wcpm_LW_A.IMG_File.Position:=I_POS;
  Zeile:='U';
  for B_Zaehler:=0 to 15 do begin
    wcpm_LW_A.IMG_File.Read(B_Byte,1);
    Zeile:=Zeile+IntToHex(B_Byte,2);
  end;

  LazSerial1.WriteData(Zeile+CRLF);

  if LOG_READ then
    ListBox_Meldungen_Add_Item_Color('<< READ('+IntToStr(ISEC_LFD_NR)+')='+Zeile,
                                     cl_dunkel_braun);

  if ISEC_LFD_NR=7 then
    DISK_MONITOR_OFF;

end; { procedure TForm_Console.Read_IMAGE_Sektor_unkomp }







procedure TForm_Console.Read_IMAGE_Sektor_komp(ISEC_LFD_NR : Byte);
var
  Zeile7, Zeile8 : String;
  DB8, DB7 : Byte;
  x1, x2, x3 : Integer;
  I_POS : LongInt;

begin

  if not PortConnected then
    Port_verbinden;

  // VAR_SECTOR, VAR_TRACK, VAR_DISKNO

  if ISEC_LFD_NR=0 then
    DISK_MONITOR_READ;

  I_POS:=(ISEC_LFD_NR*32)+(((VAR_TRACK*wcpm_LW_A.DPB.SPT)+(VAR_SECTOR))*128);

  if LOG_READ and (ISEC_LFD_NR=0) then
    ListBox_Meldungen_Add_Item_Color('Sec='+IntToStr(VAR_SECTOR)+
                       ' Trk='+IntToStr(VAR_TRACK)+' Dsk='+IntToStr(VAR_DISKNO),
                       cl_dunkel_braun);

  wcpm_LW_A.IMG_File.Position:=I_POS;
  Zeile7:='R';
  Zeile8:=Zeile7;
  x3:=6; DB7:=%10000000;

  for x1:=0 to 31 do begin

    wcpm_LW_A.IMG_File.Read(DB8,1);
    Zeile8:=Zeile8+IntToHex(DB8,2);

    for x2:=7 downto 0 do begin

      if GetBit(DB8,x2) then
        DB7 := SetBit(DB7,x3)
      else
        DB7 := ClearBit(DB7,x3);

      dec(x3);

      if x3<0 then begin
        Zeile7:=Zeile7+Char(DB7);
        x3:=6; DB7:=%10000000;
      end;

    end; { for x2:=0 to 7 do }

  end; { for x1:=0 to 31 do }


  Zeile7:=Zeile7+Char(DB7);


  LazSerial1.WriteData(Zeile7+CRLF);

  if LOG_READ then
    ListBox_Meldungen_Add_Item_Color('<< READ('+IntToStr(ISEC_LFD_NR)+')='+Zeile8,
                                     cl_dunkel_braun);

  if ISEC_LFD_NR=3 then
    DISK_MONITOR_OFF;

end; { procedure TForm_Console.Read_IMAGE_Sektor_Komp }

















procedure TForm_Console.Read_IMAGE_Sektor_komp34(ISEC_LFD_NR : Byte);
var
  Zeile_Hex, Zeile_Char : String;
  ein_Byte, Byte_01, Byte_02 : Byte;
  I_POS : LongInt;
  Zaehler : Integer;
  ein_Zeichen : Char;



  function Byte_in_Zeichen(BC_Byte : Byte) : Char;
  var
    BC_Char : Char;
  begin

    case BC_Byte of

      0..9   : BC_Char:=Chr(48+BC_Byte);
      10     : BC_Char:='<';
      11     : BC_Char:='>';
      12..37 : BC_Char:=Chr(53+BC_Byte);  // 65-12=53
      38..63 : BC_Char:=Chr(59+BC_Byte);  // 97-38=59

    else

      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: Byte_in_Zeichen='+IntToHex(BC_Byte,2)+'H ***',
                         cl_dunkel_rot);

    end;

    RESULT:=BC_Char;

  end; { function Byte_zu_Char }

begin

  if not PortConnected then
    Port_verbinden;

  // VAR_SECTOR, VAR_TRACK, VAR_DISKNO

  if ISEC_LFD_NR=0 then
    DISK_MONITOR_READ;

  I_POS:=(ISEC_LFD_NR*32)+(((VAR_TRACK*wcpm_LW_A.DPB.SPT)+(VAR_SECTOR))*128);

  if LOG_READ and (ISEC_LFD_NR=0) then
    ListBox_Meldungen_Add_Item_Color('Sec='+IntToStr(VAR_SECTOR)+
                       ' Trk='+IntToStr(VAR_TRACK)+' Dsk='+IntToStr(VAR_DISKNO),
                       cl_dunkel_braun);

  wcpm_LW_A.IMG_File.Position:=I_POS;

  LazSerial1.WriteData('K');

  Zeile_Hex:='';
  Zeile_Char:='';

  for Zaehler:=1 to 30 do begin

    // B1
    wcpm_LW_A.IMG_File.Read(ein_Byte,1);
    Zeile_Hex:=Zeile_Hex+IntToHex(ein_Byte,2)+' ';

    Byte_01:=ein_Byte shr 2;
    ein_Zeichen:=Byte_in_Zeichen(Byte_01);
    LazSerial1.WriteData(ein_Zeichen);
    Zeile_Char:=Zeile_Char+ein_Zeichen;

    Byte_01:=ein_Byte shl 4;
    Byte_01:=Byte_01 and %00110000;

    // B2
    wcpm_LW_A.IMG_File.Read(ein_Byte,1);
    Zeile_Hex:=Zeile_Hex+IntToHex(ein_Byte,2)+' ';

    Byte_02:=ein_Byte and %11110000;
    Byte_02:=Byte_02 shr 4;
    Byte_01:=Byte_01+Byte_02;
    ein_Zeichen:=Byte_in_Zeichen(Byte_01);
    LazSerial1.WriteData(ein_Zeichen);
    Zeile_Char:=Zeile_Char+ein_Zeichen;

    Byte_01:=ein_Byte shl 2;
    Byte_01:=Byte_01 and %00111100;

    // B3
    wcpm_LW_A.IMG_File.Read(ein_Byte,1);
    Zeile_Hex:=Zeile_Hex+IntToHex(ein_Byte,2)+' ';

    Byte_02:=ein_Byte and %11000000;
    Byte_02:=Byte_02 shr 6;
    Byte_01:=Byte_01+Byte_02;
    ein_Zeichen:=Byte_in_Zeichen(Byte_01);
    LazSerial1.WriteData(ein_Zeichen);
    Zeile_Char:=Zeile_Char+ein_Zeichen;

    Byte_01:=ein_Byte and %00111111;
    ein_Zeichen:=Byte_in_Zeichen(Byte_01);
    LazSerial1.WriteData(ein_Zeichen);
    Zeile_Char:=Zeile_Char+ein_Zeichen;

  end; { for x1:=1 to 30 do }



  // B1
  wcpm_LW_A.IMG_File.Read(ein_Byte,1);
  Zeile_Hex:=Zeile_Hex+IntToHex(ein_Byte,2)+' ';

  Byte_01:=ein_Byte shr 2;
  ein_Zeichen:=Byte_in_Zeichen(Byte_01);
  LazSerial1.WriteData(ein_Zeichen);
  Zeile_Char:=Zeile_Char+ein_Zeichen;

  Byte_01:=ein_Byte shl 4;
  Byte_01:=Byte_01 and %00110000;

  // B2
  wcpm_LW_A.IMG_File.Read(ein_Byte,1);
  Zeile_Hex:=Zeile_Hex+IntToHex(ein_Byte,2)+' ';

  Byte_02:=ein_Byte and %11110000;
  Byte_02:=Byte_02 shr 4;
  Byte_01:=Byte_01+Byte_02;
  ein_Zeichen:=Byte_in_Zeichen(Byte_01);
  LazSerial1.WriteData(ein_Zeichen);
  Zeile_Char:=Zeile_Char+ein_Zeichen;

  Byte_01:=ein_Byte shl 2;
  Byte_01:=Byte_01 and %00111100;

  // B3
  wcpm_LW_A.IMG_File.Read(ein_Byte,1);
  Zeile_Hex:=Zeile_Hex+IntToHex(ein_Byte,2)+' ';

  Byte_02:=ein_Byte and %11000000;
  Byte_02:=Byte_02 shr 6;
  Byte_01:=Byte_01+Byte_02;
  ein_Zeichen:=Byte_in_Zeichen(Byte_01);
  LazSerial1.WriteData(ein_Zeichen);
  Zeile_Char:=Zeile_Char+ein_Zeichen;

  Byte_01:=ein_Byte and %00111111;
  ein_Zeichen:=Byte_in_Zeichen(Byte_01);
  LazSerial1.WriteData(ein_Zeichen);
  Zeile_Char:=Zeile_Char+ein_Zeichen;


  LazSerial1.WriteData(CRLF);


  if LOG_READ then begin
    ListBox_Meldungen_Add_Item_Color('<< READ('+IntToStr(ISEC_LFD_NR)+')='+Zeile_Hex,
                                     cl_dunkel_braun);
    ListBox_Meldungen_Add_Item_Color('   '+Zeile_Char,cl_dunkel_braun);
  end;

  if ISEC_LFD_NR=3 then
    DISK_MONITOR_OFF;

end; { procedure TForm_Console.Read_IMAGE_Sektor_komp34 }








procedure TForm_Console.Write_IMAGE_Sektor_unkomp(Zeile : String);
var
  B_Zaehler, VAR_WR_LFD_NR : Integer;
  B_Byte : Byte;
  I_POS : LongInt;
  S_Zahl : String;
begin
  if not PortConnected then
    Port_verbinden;

  S_Zahl := Copy(Zeile,1,2);
  VAR_WR_LFD_NR := StrToInt('$'+S_Zahl);

  if VAR_WR_LFD_NR=0 then begin
    if LOG_WRITE then
      ListBox_Meldungen_Add_Item_Color('Sec='+IntToStr(VAR_SECTOR)+
                         ' Trk='+IntToStr(VAR_TRACK)+' Dsk='+IntToStr(VAR_DISKNO),
                         cl_dunkel_braun);
    DISK_MONITOR_WRITE;
  end;

  if LOG_WRITE then
    ListBox_Meldungen_Add_Item_Color('<< WRITE='+Zeile,cl_dunkel_braun);

  // VAR_SECTOR, VAR_TRACK, VAR_DISKNO

  I_POS:=(VAR_WR_LFD_NR*16)+(((VAR_TRACK*wcpm_LW_A.DPB.SPT)+(VAR_SECTOR))*128);

  wcpm_LW_A.IMG_File.Position:=I_POS;
  for B_Zaehler:=0 to 15 do begin
    S_Zahl := Copy(Zeile,3+(B_Zaehler*2),2);
    B_Byte := StrToInt('$'+S_Zahl);
    wcpm_LW_A.IMG_File.Write(B_Byte,1);
  end;

  if (VAR_WR_LFD_NR=7) then begin
    DISK_MONITOR_OFF;
  end; { if (VAR_WR_LFD_NR=7) then }

end; { procedure TForm_Console.Write_IMAGE_Sektor_unkomp }








procedure TForm_Console.Write_IMAGE_Sektor_komp(Zeile : String);
var
  B_Zaehler, VAR_WR_LFD_NR : Integer;
  B_Byte : Byte;
  I_POS : LongInt;
  S_Zahl : String;
begin
  if not PortConnected then
    Port_verbinden;

  // 01 D01 .. D32
  S_Zahl := Copy(Zeile,1,2);
  VAR_WR_LFD_NR := StrToInt('$'+S_Zahl);

  if VAR_WR_LFD_NR=0 then begin

    if LOG_WRITE then

      ListBox_Meldungen_Add_Item_Color('Sec='+IntToStr(VAR_SECTOR)+
                         ' Trk='+IntToStr(VAR_TRACK)+' Dsk='+IntToStr(VAR_DISKNO),
                         cl_dunkel_braun);

    DISK_MONITOR_WRITE;
  end;

  if LOG_WRITE then
    ListBox_Meldungen_Add_Item_Color('<< WRITE='+Zeile,cl_dunkel_braun);

  // VAR_SECTOR, VAR_TRACK, VAR_DISKNO, spt=72
  // 0..71, 72..143,
  // 18432 / 128 = 144 / 72 = 2

  I_POS:=(VAR_WR_LFD_NR*32)+(((VAR_TRACK*wcpm_LW_A.DPB.SPT)+(VAR_SECTOR))*128);

  wcpm_LW_A.IMG_File.Position:=I_POS;

  for B_Zaehler:=0 to 31 do begin
    S_Zahl := Copy(Zeile,3+(B_Zaehler*2),2);
    B_Byte := StrToInt('$'+S_Zahl);
    wcpm_LW_A.IMG_File.Write(B_Byte,1);
  end;

  if (VAR_WR_LFD_NR=3) then begin
    DISK_MONITOR_OFF;
  end; { if (VAR_WR_LFD_NR=4) then }


end; { procedure TForm_Console.Write_IMAGE_Sektor_komp }








procedure TForm_Console.WRITE_TO_LIST(DatenByte : Byte);
begin
  PRINT_File.Write(DatenByte,1);
end; { procedure TForm_Console.WRITE_TO_LIST }









procedure TForm_Console.sende_Datum_und_Zeit;
var
  Start_Datum : TDateTime;
  Zeile, S_Stunde, S_Minute, S_Sekunde : String;
  Diff : Word;
begin
  Start_Datum:=StrToDate('01.01.1978');
  Diff:=DaysBetween(Date, Start_Datum)+1;
  Zeile:=TimeToStr(Time);
  S_Stunde:=Copy(Zeile,1,2);
  S_Minute:=Copy(Zeile,4,2);
  S_Sekunde:=Copy(Zeile,7,2);

  Zeile:='D'+IntToHex(Diff,4)+S_Stunde+S_Minute+S_Sekunde; // D329B133357 = D + Datum(4) + Zeit(6)

  LazSerial1.WriteData(Zeile+CRLF);

  ListBox_Meldungen_Add_Item_Color('<< Datum und Zeit gesendet ('+Zeile+')',cl_dunkel_braun);


end; { procedure TForm_Console.sende_Datum_und_Zeit }









procedure TForm_Console.sende_CONIN;
var
  CI_Zeile : String;
  CI_Byte : Byte;
begin

  CI_Byte:=Form_CONS.read_key;
  CI_Zeile:='T'+IntToHex(CI_Byte,2); // T61 = T + 61H -> Tastaturwert
  LazSerial1.WriteData(CI_Zeile+CRLF);

  if LOG_CONIN then
    ListBox_Meldungen_Add_Item_Color('<< CONIN gesendet ('+CI_Zeile+')',cl_dunkel_braun);

end; { procedure TForm_Console.sende_CONIN }










procedure TForm_Console.sende_CONST;
var
  CI_Zeile : String;
  CI_Byte : Byte;

begin
  CI_Byte:=Form_CONS.read_key_stat;
  CI_Zeile:='T'+IntToHex(CI_Byte,2); // TFF = T + FF oder 00
  LazSerial1.WriteData(CI_Zeile+CRLF);

end; { procedure TForm_Console.sende_CONST }








procedure TForm_Console.sende_DEVICE_VECTOR;
var
  DV_Zeile : String;

  {
    Konfiguration WHO_ARE_YOU - Byte
    D7 - CONOUT
    D6 - CONIN
    D5 - LIST
    D4 - SOUND
    D3 - DIVE
    D2 - READER
    D1 - N.N.
    D0 - N.N.
  }

begin

  DV_Zeile:='H'+IntToHex(DEVICE_VECTOR_Byte,2); // = H + XX
  LazSerial1.WriteData(DV_Zeile+CRLF);


  if LOG_DEVICE_VECTOR then begin
    ListBox_Meldungen_Add_Item_Color('<< DEVICE_VECTOR='+
                                     IntToBin(DEVICE_VECTOR_Byte,8)+'B',cl_dunkel_braun);
  end;


end; { procedure TForm_Console.sende_DEVICE_VECTOR }







procedure TForm_Console.LazSerial1RxData(Sender: TObject);
var
  Kommando : Char;
  EmpfangsZeile : String;
  POS_KA, DatenByte{, DatenByte2} : Integer;



  procedure Convert_7_to_8;
  var
    x1, x2, x3 : Integer;
    DB7, DB8 : Byte;
    EmpfangsZeile2 : String;
  begin
    EmpfangsZeile2 := Copy(EmpfangsZeile,1,2);
    x3:=7; DB8:=$00;
    for x1:=3 to 39 do begin
      DB7 := Byte(EmpfangsZeile[x1]);
      for x2:=6 downto 0 do begin

        if GetBit(DB7,x2) then
          DB8 := SetBit(DB8,x3)
        else
          DB8 := ClearBit(DB8,x3);

        dec(x3);

        if X3<0 then begin
          EmpfangsZeile2 := EmpfangsZeile2 + IntToHex(DB8,2);
          x3:=7; DB8:=$00;
        end;

      end; { for x2:=6 downto 0 do }
    end; { for x1:=3 to 39 do }

    EmpfangsZeile := EmpfangsZeile2;

  end; { procedure Convert_7_to_8 }




begin


  ReadCOM:=ReadCOM+LazSerial1.ReadData;



  // Anfangsinitialisierung - ReadCOM leeren
  POS_KA:=Pos('@',ReadCOM);
  if POS_KA>0 then begin

    ReadCOM := '';
    ListBox_Meldungen.Items.Clear;

    Form_CONS.clear_KeyBuffer;

    ListBox_Meldungen_Add_Item_Color('>> RESET von der Hardware empfangen',cl_dunkel_blau);


  end; { if POS_KA>0 then }



  // Anfangsinitialisierung - ReadCOM leeren

  POS_KA:=Pos(#0,ReadCOM);
  if POS_KA>0 then begin

    // CheckBox_XOFF
    if CheckBox_XOFF.Checked then begin

      LazSerial1.WriteData(XOFF);
      ListBox_Meldungen_Add_Item_Color('>> XOFF gesendet ...',cl_dunkel_blau);

    end;

    ReadCOM := '';

  end; { if POS_KA>0 then }




  while Pos(CRLF,ReadCOM)>0 do begin { Befehlszeile wurde vollstaendig empfangen }

        if Length(ReadCOM)>Length(CRLF) then begin
          Kommando:=ReadCOM[1];
          Delete(ReadCOM,1,1);
          case Kommando of


            'd' : begin // Datum und Zeit
                    if Pos(CRLF,ReadCOM)=1 then begin
                      Delete(ReadCOM,1,Length(CRLF));
                      sende_Datum_und_Zeit;
                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

                  end; { 'd' }


            'e' : begin // letzte Pruefsumme

                    if Pos(CRLF,ReadCOM)=5 then begin
                      EmpfangsZeile:=Copy(ReadCOM,1,4);
                      Delete(ReadCOM,1,4+Length(CRLF));
                      DatenByte:=StrToInt('$'+EmpfangsZeile);

                      if DatenByte=letzte_Pruefsumme then begin

                         if LOG_READ then
                           ListBox_Meldungen_Add_Item_Color('... letzte_Pruefsumme='+
                                                IntToHex(DatenByte,4)+'H ist o.k.',
                                                cl_dunkel_rot);

                      end
                      else begin

                        ListBox_Meldungen_Add_Item_Color('*** ERROR *** gesendete Pruefsumme='+
                           IntToHex(letzte_Pruefsumme,4)+'H ist ungleich der '+
                           'empfangenen Pruefsumme='+
                           IntToHex(DatenByte,4)+'H ***',
                           cl_dunkel_rot);

                      end; { if DatenByte=letzte_Pruefsumme then }

                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);
                  end; { 'e' }





            'h' : begin // DEVICE_VECTOR

                    if Pos(CRLF,ReadCOM)=1 then begin
                      Delete(ReadCOM,1,Length(CRLF));
                      sende_DEVICE_VECTOR;
                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

                  end; { 'h' }



            'i' : begin // CONIN

                    if Pos(CRLF,ReadCOM)=1 then begin
                      Delete(ReadCOM,1,Length(CRLF));
                      sende_CONIN;
                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

                  end; { 'i' }


            'j' : begin // CONST

                    if Pos(CRLF,ReadCOM)=1 then begin
                      Delete(ReadCOM,1,Length(CRLF));
                      sende_CONST;
                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

                  end; { 'j' }


            'l' : begin // LIST
                    if Pos(CRLF,ReadCOM)=3 then begin
                      EmpfangsZeile:=Copy(ReadCOM,1,2);
                      Delete(ReadCOM,1,2+Length(CRLF));
                      DatenByte:=StrToInt('$'+EmpfangsZeile);
                      WRITE_TO_LIST(DatenByte);
                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

                  end; { 'l' }


            'o' : begin // CONOUT

                    if Pos(CRLF,ReadCOM)=3 then begin
                      EmpfangsZeile:=Copy(ReadCOM,1,2);
                      Delete(ReadCOM,1,2+Length(CRLF));
                      DatenByte:=StrToInt('$'+EmpfangsZeile);

                      if LOG_CONOUT then
                        ListBox_Meldungen_Add_Item_Color('conout='+IntToHex(DatenByte,2),
                                                         cl_dunkel_braun);

                      Form_CONS.RECEIVE_FROM_CONOUT(DatenByte);

                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

                  end; { 'o' }




            'k' : begin // Read IMAGE Sektor komprimiert 34
                    if Pos(CRLF,ReadCOM)=3 then begin
                      EmpfangsZeile:=Copy(ReadCOM,1,2);
                      DatenByte:=StrToInt('$'+EmpfangsZeile); // ISEC_LFD_NR
                      Delete(ReadCOM,1,2+Length(CRLF));
                      Read_IMAGE_Sektor_komp34(DatenByte);
                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

                  end; { 'k' }




            'r' : begin // Read IMAGE Sektor - komprimiert
                    if Pos(CRLF,ReadCOM)=3 then begin
                      EmpfangsZeile:=Copy(ReadCOM,1,2);
                      DatenByte:=StrToInt('$'+EmpfangsZeile); // ISEC_LFD_NR
                      Delete(ReadCOM,1,2+Length(CRLF));
                      Read_IMAGE_Sektor_komp(DatenByte);
                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

                  end; { 'r' }



            's' : begin // Sector, Track, Drive (STD) = s SE TH TL DR
                    if Pos(CRLF,ReadCOM)=9 then begin
                      // VAR_SECTOR, VAR_TRACK, VAR_DISKNO

                      RW_Sperre2:=true;
                      EmpfangsZeile:=Copy(ReadCOM,1,2);
                      VAR_SECTOR:=StrToInt('$'+EmpfangsZeile); // VAR_SECTOR
                      EmpfangsZeile:=Copy(ReadCOM,3,4);
                      VAR_TRACK:=StrToInt('$'+EmpfangsZeile); // VAR_TRACK
                      EmpfangsZeile:=Copy(ReadCOM,7,2);
                      VAR_DISKNO:=StrToInt('$'+EmpfangsZeile); // VAR_DISKNO
                      Delete(ReadCOM,1,8+Length(CRLF));

                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

                  end; { 's' }


                  { 'T' fuer CONIN genutzt }


            'u' : begin // Read IMAGE Sektor (unkomprimiert)
                    if Pos(CRLF,ReadCOM)=3 then begin
                      EmpfangsZeile:=Copy(ReadCOM,1,2);
                      DatenByte:=StrToInt('$'+EmpfangsZeile); // ISEC_LFD_NR
                      Delete(ReadCOM,1,2+Length(CRLF));
                      Read_IMAGE_Sektor_unkomp(DatenByte);
                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

                  end; { 'u' }




            // v NR D32 = v + 34 = 35
            'v' : begin // Write IMAGE Sektor (unkomprimiert)
                    if Pos(CRLF,ReadCOM)=35 then begin
                      EmpfangsZeile:=Copy(ReadCOM,1,34);
                      Delete(ReadCOM,1,34+Length(CRLF));
                      Write_IMAGE_Sektor_unkomp(EmpfangsZeile);
                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

                  end; { 'v' }



                  // w NR DB7_01 .. DB7_37 = 37 + 2 = 39 + w
            'w' : begin // Write IMAGE Sektor - komprimiert
                    if Pos(CRLF,ReadCOM)=40 then begin
                      EmpfangsZeile:=Copy(ReadCOM,1,39);
                      Delete(ReadCOM,1,39+Length(CRLF));

                      Convert_7_to_8;

                      Write_IMAGE_Sektor_komp(EmpfangsZeile);
                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

            end; { 'w' }





            'x' : begin // Fehlernummer
                    if Pos(CRLF,ReadCOM)=3 then begin
                      EmpfangsZeile:=Copy(ReadCOM,1,2);
                      Delete(ReadCOM,1,2+Length(CRLF));
                      ListBox_Meldungen_Add_Item_Color( '>> Fehler Nr: '+EmpfangsZeile+
                                                  ' vom Mikrocontroller gesendet',cl_dunkel_rot);
                    end
                    else
                      ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: zu viele Parameter in den Daten ('+ReadCOM+') ***',
                         cl_dunkel_rot);

                  end; { 'x' }


            'y' : begin  // Kommentare
                      EmpfangsZeile:=Copy(ReadCOM,1,Pos(CRLF,ReadCOM)-1);
                      Delete(ReadCOM,1,Pos(CRLF,ReadCOM)-1+Length(CRLF));
                      ListBox_Meldungen_Add_Item_Color('*** '+EmpfangsZeile,cl_dunkel_braun);
                  end; { 'y' }


          else
            ListBox_Meldungen_Add_Item_Color(
                         '*** Fehler: das Kommando:'+Kommando+
                         ' ('+IntToHex(Ord(Kommando),2)+') ist nicht definiert ***',
                         cl_dunkel_rot);

          end;

        end { if Length(ReadCOM)>Length(CRLF) then }
        else
          ListBox_Meldungen_Add_Item_Color('*** Fehler: kein Kommando in der Befehlszeile ***',
                                           cl_dunkel_rot);


      end; { while Pos(CRLF,ReadCOM)>0 do }



end; { procedure TForm_Console.LazSerial1RxData }










procedure TForm_Console.Timer2Timer(Sender: TObject);
begin
  DISK_MONITOR_SOUND;
  Timer2.Enabled:=false;
end; { procedure TForm_Console.Timer2Timer }










procedure TForm_Console.CheckBox_LOG_CONINChange(Sender: TObject);
begin
  LOG_CONIN:=CheckBox_LOG_CONIN.Checked;
end; { procedure TForm_Console.CheckBox_LOG_CONINChange }



procedure TForm_Console.CheckBox_LOG_CONOUTChange(Sender: TObject);
begin
  LOG_CONOUT:=CheckBox_LOG_CONOUT.Checked;
end; { procedure TForm_Console.CheckBox_LOG_CONOUTChange }



procedure TForm_Console.CheckBox_LOG_READChange(Sender: TObject);
begin
  LOG_READ:=CheckBox_LOG_READ.Checked;
end; { procedure TForm_Console.CheckBox_LOG_READChange }



procedure TForm_Console.CheckBox_LOG_WRITEChange(Sender: TObject);
begin
  LOG_WRITE:=CheckBox_LOG_WRITE.Checked;
end; { procedure TForm_Console.CheckBox_LOG_WRITEChange }




procedure TForm_Console.ComboBox_FontSize_abfragen;
begin

  case ComboBox_FontSize.ItemIndex of

    0 : CONS_FontSize:=6;
    1 : CONS_FontSize:=8;
    2 : CONS_FontSize:=10;
    3 : CONS_FontSize:=14;
    4 : CONS_FontSize:=16;
    5 : CONS_FontSize:=18;
    6 : CONS_FontSize:=20;
    7 : CONS_FontSize:=22;
    8 : CONS_FontSize:=24;
    9 : CONS_FontSize:=26;

  else
    CONS_FontSize:=10;
  end;

  Form_CONS.MAIN_ComboBox_FontSize_Index:=ComboBox_FontSize.ItemIndex;

end; { procedure TForm_Console.ComboBox_FontSize_abfragen }





procedure TForm_Console.ComboBox_FontSizeChange(Sender: TObject);
begin

  ComboBox_FontSize_abfragen;
  Form_CONS.Formular_neu_zeichnen;

  ListBox_Meldungen_Add_Item_Color('*** FontSize auf '+IntToStr(CONS_FontSize)+' gesetzt',
                                           cl_dunkel_blau);

end; { procedure TForm_Console.ComboBox_FontSizeChange }





procedure TForm_Console.ComboBox_FontSize_aendern;
begin

  ComboBox_FontSize.ItemIndex:=Form_CONS.MAIN_ComboBox_FontSize_Index;
  ComboBox_FontSize_abfragen;
  Form_CONS.Formular_neu_zeichnen;

  ListBox_Meldungen_Add_Item_Color('*** FontSize auf '+IntToStr(CONS_FontSize)+' gesetzt',
                                           cl_dunkel_blau);

end; { procedure TForm_Console.ComboBox_FontSize_aendern }







procedure TForm_Console.ComboBox_TIEChange(Sender: TObject);
begin
  Form_CONS.SET_EmuMode;
end; { procedure TForm_Console.ComboBox_TIEChange }





procedure TForm_Console.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  if Shift = [] then
    case Key of
      27 : Form_Console.Close; // ESC
  end; { if Shift = [] then }

end; { procedure TForm_Console.FormKeyDown }




procedure TForm_Console.FormResize(Sender: TObject);
begin

  if Form_Console.Width>500 then
    Form_Console.Width:=500;

  if Form_Console.Width<500 then
    Form_Console.Width:=500;

  if Form_Console.Height<660 then
    Form_Console.Height:=660;

  if Form_Console.Height>1000 then
    Form_Console.Height:=1000;

end; { procedure TForm_Console.FormResize }




procedure TForm_Console.FormShow(Sender: TObject);
begin
  Form_Console.Left := F1_x;
  Form_Console.Top := F1_y;
  Form_Console.Height := F1_Hoehe;
end; { procedure TForm_Console.FormShow }




procedure TForm_Console.TerminalKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

  if Shift = [] then
    case Key of
      27 : Form_Console.Close; // ESC
  end; { if Shift = [] then }

end; { procedure TForm_Console.TerminalKeyDown }





procedure TForm_Console.Timer1Timer(Sender: TObject);
begin

  if DISK_MONITOR_Zaehler>0 then begin

    DEC(DISK_MONITOR_Zaehler);

    if DISK_MONITOR_Zaehler=0 then begin

      DISK_MONITOR_OFF;

    end; { if DISK_MONITOR_Zaehler=0 then }

  end; { if DISK_MONITOR_Zaehler>0 then }

end; { procedure TForm_Console.Timer1Timer }









{ ***** Listbox_Meldungen ***** }


procedure TForm_Console.ListBox_Meldungen_Clear;
var
  FC_counter : Integer;

begin

  for FC_counter:=0 to Length_Color_List do begin
    Color_List[FC_counter]:=ClBlack;
  end;

  ListBox_Meldungen.Clear;

end; { procedure TForm_Console.ListBox_Meldungen_Clear }




procedure TForm_Console.ListBox_Meldungen_Add_Item_Color(AI_Text : String;
                                  AI_Color : TColor);
var
  AI_Index : Integer;

begin

  ListBox_Meldungen.Items.Add(AI_Text);
  AI_Index:=ListBox_Meldungen.Count-1;

  if AI_Index<Length_Color_List then
    Color_List[AI_Index]:=AI_Color
  else
    Color_List[0]:=AI_Color;

  SendMessage(ListBox_Meldungen.Handle, LB_SETTOPINDEX, ListBox_Meldungen.Items.Count-1, 0);

end; { procedure TForm_Console.ListBox_Meldungen_Add_Item_Color }




procedure TForm_Console.ListBox_MeldungenDrawItem(Control: TWinControl;
  Index: Integer; ARect: TRect; State: TOwnerDrawState);
var
  VG_Color : TColor;
begin

  with (Control as TListbox) do begin

    if Index<Length_Color_List then begin

      VG_Color:=Color_List[Index];
      Canvas.Font.Color:=VG_Color;

      Canvas.FillRect(ARect); // Hintergrund malen
      Canvas.TextOut(ARect.Left, ARect.Top, Items[Index]); // Text ausgeben

    end; { if Index<Length_Color_List then }

  end; { with (Control as TListbox) do }

end; { procedure TForm_Console.ListBox_MeldungenDrawItem }










// *** Buttons unten ***




procedure TForm_Console.Button_LOG_Meldungen_ClearClick(Sender: TObject);
begin
  ListBox_Meldungen_Clear;
end; { procedure TForm_Console.Button_LOG_Meldungen_ClearClick }




procedure TForm_Console.Button_LOG_Meldungen_SaveClick(Sender: TObject);
begin
    ListBox_Meldungen.Items.SaveToFile(Programm_File_Pfad+PRINT_File_Ordner+Pfadtrenner+'LOG_Meldungen.txt');
end; { procedure TForm_Console.Button_LOG_Meldungen_SaveClick }




procedure TForm_Console.Button_CloseClick(Sender: TObject);
begin
  Close;
end; { procedure TForm_Console.ButtonCloseClick }















procedure TForm_Console.FormDestroy(Sender: TObject);
begin

  if PortConnected then
    LazSerial1.Close;

  if Assigned(FIni) then begin

    FIni.WriteInteger('FORM','F1_x', Form_Console.Left );
    FIni.WriteInteger('FORM','F1_y', Form_Console.Top );
    FIni.WriteInteger('FORM','F1_Hoehe', Form_Console.Height );

    FIni.WriteInteger('FORM','F2_x', Form_CONS.Left );
    FIni.WriteInteger('FORM','F2_y', Form_CONS.Top );

    FIni.WriteBool('FORM','LOG_CONIN', LOG_CONIN );
    FIni.WriteBool('FORM','LOG_CONOUT', LOG_CONOUT );
    FIni.WriteBool('FORM','LOG_READ', LOG_READ );
    FIni.WriteBool('FORM','LOG_WRITE', LOG_WRITE );

    FIni.WriteBool('FORM','LOG_Term', CheckBox_LOG_TERM.Checked );
    FIni.WriteBool('FORM','send_XOFF', CheckBox_XOFF.Checked );


    FIni.WriteString('ComPort', 'ComPort', ComboBoxPort.Items[ComboBoxPort.itemindex] );
    FIni.WriteInteger('ComPort','BaudRate', ComboBoxBauds.itemindex );


    FIni.WriteInteger('CONOUT', 'Index_Emulation', ComboBox_TIE.ItemIndex );
    FIni.WriteInteger('CONOUT', 'Index_FontSize', ComboBox_FontSize.ItemIndex );
    FIni.WriteString('CONOUT', 'DEVICE_VECTOR', IntToBin(DEVICE_VECTOR_Byte,8) );
    FIni.WriteString('CONOUT', 'FONT_NAME', GV_Font_Name );
    FIni.WriteBool('CONOUT','play_SOUND', CheckBox_SOUND.Checked );



    FIni.WriteString('PRINT', 'File_Name', PRINT_File_Name );
    FIni.WriteString('PRINT', 'File_Ordner', PRINT_File_Ordner );


    FIni.WriteString('CPM','DRIVE_A', DRIVE_A );


    FIni.UpdateFile;
    FIni.Free;
  end; { if Assigned(FIni) then }


  BOOT_File.Free;


  // Serial-Port schliessen, falls noch offen
  if LazSerial1.Active then
    LazSerial1.Close;



  wcpm_LW_A.Export_Files_From_Image;
  wcpm_LW_A.Destroy;



  if PRINT_File.Size>0 then
    PRINT_File.SaveToFile(Programm_File_Pfad+PRINT_File_Ordner+Pfadtrenner+PRINT_File_Name);

  PRINT_File.Free;

end; { procedure TForm_Console.FormDestroy }







initialization
  {$I MainUnit.lrs}

end.

